########################################################################
#	File	:	utWvϊXNvg
#	Create	:	2005/01/20
#	Author	:	hishida
#	Purpose	:	RwǧJeLXgEBStudiopHTMLɕϊ
#	啶Ŏn܂ϐ̓O[oA_Ŏn܂ϐ̓[J
#				2008/07/31	tWeLXg Ver 5.0 R1.3 ɑΉ
########################################################################

# K\ɂuEUCōsjcodegp
require './jcode.pl';


$INFILE = $ARGV[0];
$OUTFILE = $ARGV[1];

LoadGaiji();
LoadKeyword();
LoadFigList();


open(IN, $INFILE );
if ( ! -e IN  ) {
    printf( STDOUT "%s not found!\n", $INFILE );
    exit;
}

open(OUT, ">" . $OUTFILE );
ClearData();

PrintHead();

while (<IN>) {
	chomp();
	if ( $_ eq "" ) {
		PrintData();
		ClearData();
	}
	elsif ( /#\[ԍ\]([0-9]+)\/([0-9]+)/ ) {
		$Kan	= $1;
		$Bango	= $2;
		if ( $Kan ne $OldKan ) {
			if ( $Kan ne "01" ) {	print OUT "</dl>\n";	};
			print OUT "<h2>$Kanmei{$Kan}</h2>\n" ;
			print OUT "<dl>\n" ;
			$OldKan	= $Kan;
		}
	}
	elsif ( /#\[莌\](.*)/ ) {
		$value	= $1;
		&jcode'convert(*value, "euc");
		# / ͉s
		$value	=~ s/\//!/g;
		$value	=~ s/</&lt;/g;
		$value	=~ s/>/&gt;/g;
		$value	=~ s/!/<br \/>/g;
		# []͏
		$value	=~ s/\[/<sub>/g;
		$value	=~ s/\]/<\/sub>/g;
		&jcode'convert(*value, "sjis");
		$Daisi	= ConvGaiji( $value );
	}
	elsif ( /#\[\](.*)/ ) {
		$value	= $1;
		&jcode'convert(*value, "euc");
		$value	=~ s/</&lt;/g;
		$value	=~ s/>/&gt;/g;
		# []͏
		$value	=~ s/\[/<sub>/g;
		$value	=~ s/\]/<\/sub>/g;
		&jcode'convert(*value, "sjis");
		$Genbun	= ConvGaiji( $value );
	}
	elsif ( /#\[P\](.*)/ ) {
		$value	= $1;
		&jcode'convert(*value, "euc");
		$value	=~ s/</&lt;/g;
		$value	=~ s/>/&gt;/g;
		# []͏
		$value	=~ s/\[/<sub>/g;
		$value	=~ s/\]/<\/sub>/g;
		&jcode'convert(*value, "sjis");
		$Kundoku= $value;
	}
	elsif ( /#\[\](.*)/ ) {
		$Kana	= $1;
	}
	elsif ( /#\[\](.*)/ ) {
		$value	= $1;
		&jcode'convert(*value, "euc");
		$value	=~ s/</&lt;/g;
		$value	=~ s/>/&gt;/g;
		# []͏
		$value	=~ s/\[/<sub>/g;
		$value	=~ s/\]/<\/sub>/g;
		&jcode'convert(*value, "sjis");
		$Satyu	= ConvGaiji( $value );
	}
	elsif ( /#\[Z\](.*)/ ) {
		$Koui	= ConvGaiji( $1 );
	}
	elsif ( /#\[jv\](.*)/ ) {
		$KW	= $1;
	}
	elsif ( /#\[\](.*)/ ) {
		$KW	= $1;
	}
}
close(IN);

if ( $Bango>0 ) {
	PrintData();
}
PrintFoot();
close(OUT);
MakeComplex();


########################################################################
# ֐
########################################################################

sub ClearData
{
	$Kan	= 0;
	$Bango	= 0;
	$Daisi	= "";
	$Genbun	= "";
	$Kundoku= "";
	$Kana	= "";
	$Satyu	= "";
	$Koui	= "";
	$KW	= "";
}

# HTML wb_쐬
sub PrintHead
{
	print OUT "<?xml version=\"1.0\" encoding=\"Shift_JIS\"?>\n" ;
	#print OUT "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\"\n" ;
	#print OUT " \"DTD/xhtml1-transitional.dtd\">\n" ;
	print OUT "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"ja\" lang=\"ja\">\n" ;
	print OUT "<head>\n" ;
	print OUT "<title>tW</title>\n" ;
	print OUT "</head>\n" ;
	print OUT "<body>\n" ;

	print OUT "<h2>utWv`{ {莛{`</h2>\n" ;

}

# HTML tb^쐬
sub PrintFoot
{
	print OUT "</dl>\n" ;
	print OUT "</body>\n" ;
	print OUT "</html>\n" ;
}

# R[ho
sub PrintData
{
	# oŔԍ̂Ȃ̂͏o͂Ȃ
	if ( $Bango>0 ) {
		@list = split( / / , $Kundoku );
		if ( $#list > 7 ) {	# 
			$_title = $Kan."/".$Bango ." ".$list[0]." ".$list[1]." ".$list[2]." ".$list[3]." ".$list[4]." ".$list[5]." ".$list[6]." ".$list[7]."c";
		}
		else {	# Z
			$_title = $Kan."/".$Bango ." ".$Kundoku;
		}
		print OUT "<h3 id=\"$Bango\" title=\"$_title\">$Kan/$Bango</h3>\n";
		print OUT "<key type=\"\\L\">$Bango</key>\n";
	}
#	print OUT "<p>\n";
	if ( $KW ne "" ) {
		# geLXgɂȂL[[hǉ
		if ( $Daisi =~ /.*qS.*/ &&  $KW !~ /.*qS.*/ ) {
			$KW = ",qS" . $KW;
		}
		elsif ( $Daisi =~ /.*񕨒v.*/ && $KW !~ /.*񕨒v.*/ ) {
			$KW = ",񕨒v" . $KW;
		}
		@_kwd =  split(/,/,$KW);
		foreach $_i (@_kwd) {
			if ( $_i eq "" ) { next; };
			if ( $_i =~ /^ҁF/ ) {
				$_i =~ s/^ҁF//;
				print OUT "<key type=\"\" name=\"\">$_i</key>\n";
			}
			elsif ( $KWTimei{$_i} ) {
				print OUT "<key type=\"\" name=\"n\">$_i</key>\n";
			}
			elsif ( $KWBudate{$_i} ) {
				print OUT "<key type=\"\" name=\"\">$_i</key>\n";
			}
			elsif ( $KWKanren{$_i} ) {
				print OUT "<key type=\"\" name=\"֘Al\">$_i</key>\n";
			}
			else {
				$KWZikou{$_i}	= 1;
				print OUT "<key type=\"\" name=\"\">$_i</key>\n";
			}
		}
		foreach $_i (@_kwd) {
			if ( $_i eq "" ) { next; };
			$_i =~ s/^ҁF//;
			print OUT "<key type=\"\">$_i</key>\n";
		}
		@_kun =  split(/  /,$Kundoku);
		foreach $_i (@_kun) {
			if ( $_i eq "" ) { next; };
			print OUT "<key type=\"\\L\">$_i</key>\n";
		}
	}
	if ( $Kana ne "" ) {
		@_kwd =  split(/,/,$Kana);
		foreach $_i (@_kwd) {
			if ( $_i ne "" ) {
				print OUT "<key type=\"\">$_i</key>\n";
			}
		}
	}

	if ( $Daisi ne "" ) {
		print OUT "<p>$Daisi</p>\n";
	}
	if ( $Genbun ne "" ) {
		print OUT "<p><b>[]</b> $Genbun</p>\n";
	}
	if ( $Kundoku ne "" ) {
		print OUT "<p><b>[P]</b> $Kundoku</p>\n";
	}
	if ( $Kana ne "" ) {
		$Kana	=~ s/,/ /g;
		print OUT "<p><b>[]</b> $Kana</p>\n";
	}
	if ( $Satyu ne "" ) {
		print OUT "<p><b>[]</b> $Satyu</p>\n";
	}
	if ( $Koui ne "" ) {
		print OUT "<p><b>[Z]</b> $Koui</p>\n";
	}
	if ( $KW ne "" ) {
		print OUT "<p><b>[]</b> $KW</p>\n";
	}

	if ( $FIGList{ $Bango } ) {
		print OUT "<img src=\"images\\$FIGList{ $Bango }\">";
	}


	if ( $Bango>0 ) {
		print OUT "<br />\n";
	}


#	print OUT "</p>\n";
}

# O`t@C(gaiji.txt)ǂݍ
sub LoadGaiji
{
	#	Unicode	ebcode		O
	#`	&#xE000;	A121	i&M065167;j	G[Z][]

	open(IN, "./skel/gaiji.txt" );
	if ( ! -e IN  ) {
	    printf( STDOUT "%s not found!\n", "gaiji.txt" );
	    exit;
	}
	while (<IN>) {
		chomp();
		if ( $_ eq "" ) { next; };
		if ( substr($_,0,1) eq "#" ) { next; };

		@_item =  split(/\t/,$_);
		$GaijiMap{ @_item[0] }	= @_item[1];
	}
	close(IN);

############################################################## debug
#	while (($name, $value) = each(%GaijiMap)) {
#		print $name,"=",$value,"\n";
#	}
##############################################################

}

# Ɋ܂܂Oϊ
sub ConvGaiji
{
	my($val) = @_;
	my($vlen,$oval,$i,$c);
	$oval	= "";
	$vlen = length($val);

	@xx = unpack("C*", $val);
	while ($#xx>=0) {
		$i = shift( @xx );
		$c = pack("C",$i);
		if ( $i>=0x81 && $i<=0x9F || $i>=0xE0 && $i<=0xFC ) {
			$i = shift( @xx );
			$c = $c . pack("C",$i);
		}
		if ( $GaijiMap{ $c } ) {
			$oval = $oval . $GaijiMap{ $c };
		}
		else {
			$oval = $oval . $c;
		}
	}
	return $oval;
}

# }ŃXgǂݍ	2008/8/11
sub LoadFigList
{
	open(IN, "./skel/FIGLIST.txt" );
	if ( ! -e IN  ) {
	    printf( STDOUT "%s not found!\n", "FIGLIST.txt" );
	    exit;
	}
	while (<IN>) {
		chomp();
		if ( $_ eq "" ) { next; };
		if ( substr($_,0,1) eq "#" ) { next; };
		@_item =  split(/\t/,$_);
		$FIGList{ @_item[0] }	= @_item[1];
	}
	close(IN);
}

# L[[h̊O`ǂݍ
sub LoadKeyword
{
# 
	open(IN, "./skel/KWSAKUSYA.txt" );
	if ( ! -e IN  ) {
	    printf( STDOUT "%s not found!\n", "KWSAKUSYA.txt" );
	    exit;
	}
	while (<IN>) {
		chomp();
		if ( $_ ne "" ) {
			$KWSakusya{ $_ } = 1;
		}
	}
	close(IN);

# n
	open(IN, "./skel/KWTIMEI.txt" );
	if ( ! -e IN  ) {
	    printf( STDOUT "%s not found!\n", "KWTIMEI.txt" );
	    exit;
	}
	while (<IN>) {
		chomp();
		if ( $_ ne "" ) {
			$KWTimei{ $_ } = 1;
		}
	}
	close(IN);

# 
	open(IN, "./skel/KWBUDATE.txt" );
	if ( ! -e IN  ) {
	    printf( STDOUT "%s not found!\n", "KWBUDATE.txt" );
	    exit;
	}
	while (<IN>) {
		chomp();
		if ( $_ ne "" ) {
			$KWBudate{ $_ } = 1;
		}
	}
	close(IN);

# ֘Al
	open(IN, "./skel/KWKANREN.txt" );
	if ( ! -e IN  ) {
	    printf( STDOUT "%s not found!\n", "KWKANREN.txt" );
	    exit;
	}
	while (<IN>) {
		chomp();
		if ( $_ ne "" ) {
			$KWKanren{ $_ } = 1;
		}
	}
	close(IN);


	$Kanmei{ "01" }	= "";
	$Kanmei{ "02" }	= "";
	$Kanmei{ "03" }	= "O";
	$Kanmei{ "04" }	= "l";
	$Kanmei{ "05" }	= "";
	$Kanmei{ "06" }	= "Z";
	$Kanmei{ "07" }	= "";
	$Kanmei{ "08" }	= "";
	$Kanmei{ "09" }	= "";
	$Kanmei{ "10" }	= "\x8F\x5C";

	$Kanmei{ "11" }	= "\x8F\x5C";
	$Kanmei{ "12" }	= "\x8F\x5C";
	$Kanmei{ "13" }	= "\x8F\x5CO";
	$Kanmei{ "14" }	= "\x8F\x5Cl";
	$Kanmei{ "15" }	= "\x8F\x5C";
	$Kanmei{ "16" }	= "\x8F\x5CZ";
	$Kanmei{ "17" }	= "\x8F\x5C";
	$Kanmei{ "18" }	= "\x8F\x5C";
	$Kanmei{ "19" }	= "\x8F\x5C";
	$Kanmei{ "20" }	= "\x8F\x5C";

}

# EBStudio̕`t@C𐶐
sub MakeComplex
{
	open(CPLXF, ">" . "./complex.xml" );

	print CPLXF "<?xml version=\"1.0\" encoding=\"Shift_JIS\"?>\n" ;
	print CPLXF "<complex>\n" ;
	print CPLXF "<group>\n" ;

# 
	print CPLXF "<category name=\"\">\n" ;
	@xx = ();
	while (($name, $value) = each(%KWBudate)) {
		push(@xx, $name);
	}
	@result	= sort(@xx);
	foreach $name (@result) {
		print CPLXF "\t<subcategory name=\"$name\" />\n" ;
	}
	print CPLXF "</category>\n" ;
# 
	print CPLXF "<category name=\"\">\n" ;
	@xx = ();
	while (($name, $value) = each(%KWSakusya)) {
		push(@xx, $name);
	}
	@result	= sort(@xx);
	foreach $name (@result) {
		$name =~ /ҁF(.+)/;
		print CPLXF "\t<subcategory name=\"$1\" />\n" ;
	}
	print CPLXF "</category>\n" ;
# ֘Al
	print CPLXF "<category name=\"֘Al\">\n" ;
	@xx = ();
	while (($name, $value) = each(%KWKanren)) {
		push(@xx, $name);
	}
	@result	= sort(@xx);
	foreach $name (@result) {
		print CPLXF "\t<subcategory name=\"$name\" />\n" ;
	}
	print CPLXF "</category>\n" ;
# n
	print CPLXF "<category name=\"n\">\n" ;
	@xx = ();
	while (($name, $value) = each(%KWTimei)) {
		push(@xx, $name);
	}
	@result	= sort(@xx);
	foreach $name (@result) {
		print CPLXF "\t<subcategory name=\"$name\" />\n" ;
	}
	print CPLXF "</category>\n" ;
# 
	print CPLXF "<category name=\"\">\n" ;
	@xx = ();
	while (($name, $value) = each(%KWZikou)) {
		push(@xx, $name);
	}
	@result	= sort(@xx);
	foreach $name (@result) {
		print CPLXF "\t<subcategory name=\"$name\" />\n" ;
	}
	print CPLXF "</category>\n" ;


	print CPLXF "</group>\n" ;
	print CPLXF "</complex>\n" ;

	close( CPLXF);
}
